

import {Component, ViewChild} from "@angular/core";
import {NavController, App,ToastController, Slides} from "ionic-angular";
import {AuthService} from "../../providers/auth-service";
import {Common} from "../../providers/common";
import {PosPenjualan} from '../pos-penjualan/pos-penjualan';
import {PosRegistrasiKas} from '../pos-registrasi-kas/pos-registrasi-kas';
import {ReportPage} from '../report/report';
import {ProductPage} from '../product/product';

@Component({selector: "page-home", templateUrl: "home.html"})
export class HomePage {
    @ViewChild(Slides) slides: Slides;
    checkScreen() {
        if (window.innerWidth >= 960) {
            return 3;
        } else {
            return 2.125;
        }
    }
    public userDetails: any;
    public resposeData: any;
    public dataSet: any;
    public noRecords: boolean;
    public dataProduct: any;
    public resposeProduct: any;
    public kas_awal:number;
    userPostData = {
        user_id: "",
        username: "",
        token: "",
        feed: "",
        feed_id: "",
        lastCreated: ""
    };

    constructor(
        public navCtrl: NavController,
        public app: App,
        public common: Common,
        public authService: AuthService,
        private toastCtrl: ToastController
    ) {
        var d = new Date(), month = '' + (d.getMonth() + 1), day = '' + d.getDate(), year = d.getFullYear();
        var n = year + "-" + month + "-" + day;

        const data = JSON.parse(localStorage.getItem("userData"));
        this.userDetails = data.userData;
        this.userPostData.user_id = this.userDetails.user_id;
        this.userPostData.username = this.userDetails.username;
        this.userPostData.token = this.userDetails.token;
        this.userPostData.lastCreated = n;
        this.noRecords = false;
        this.getSaldoKas();
        this.getProduk();
    }

    getSaldoKas() {
        this.common.presentLoading();
        this.authService.postData(this.userPostData, "DashGetSaloKasAwal").then(
            result => {
                this.resposeData = result;
                if (this.resposeData.feedData) {
                    this.common.closeLoading();
                    this.dataSet = this.resposeData.feedData;
                    this.kas_awal = this.dataSet[0].kas_awal;
                    const dataLength = this.resposeData.feedData.length;
                    if (dataLength == 0) {
                        this.noRecords = true;
                    }
                } else {
                    this.common.closeLoading();
                    this.noRecords = true;
                }
            },
            err => {
                this.common.closeLoading();
                this.noRecords = true;
            }
        );
    }

    getProduk() {
        this.authService.postData(this.userPostData, "product").then(
            result => {
                this.resposeProduct = result;
                if (this.resposeProduct.productData) {
                    this.dataProduct = this.resposeProduct.productData;
                    const dataLength = this.resposeProduct.productData.length;
                    if (dataLength == 0) {
                        this.noRecords = true;
                    }
                } else {
                    this.noRecords = true;
                }
            },
            err => {
                this.noRecords = true;
            }
        );
    }
    presentToast(msg) {
        let toast = this.toastCtrl.create({
            message: msg,
            duration: 3000
        });
        toast.present();
    }

    converTime(time) {
        let a = new Date(time * 1000);
        return a;
    }

    backToWelcome() {
        const root = this.app.getRootNav();
        root.popToRoot();
    }
    createPenjualan() {
        if(this.kas_awal > 0){
            this.navCtrl.setRoot(PosPenjualan);
        }else{
            this.navCtrl.push(PosRegistrasiKas);
        } 
    }
    
    goToLaporan(){
        this.navCtrl.setRoot(ReportPage);
    }
    
    goToProduct(){
        this.navCtrl.setRoot(ProductPage);
    }
    logout() {
        //Api Token Logout
        localStorage.clear();
        setTimeout(() => this.backToWelcome(), 1000);
    }
}
